<?php

namespace ACL\Repositories;

use ACL\Traits\TQuery;
use ACL\Helpers\Instances\InstanceProvider;
use Doctrine\ORM\EntityManager;

class Pais extends RepositoryBase {

    Use TQuery;

    protected $table = 'PAIS';

    /** @var EntityManager */
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        parent::__construct($this->table);
        $this->entityManager = $entityManager;
    }

    /**
     * @param $organizationId
     * @return array
     */
    public function findAllPais($organizationId): array
    {
        $query = <<<SQL
            SELECT CDPAIS, NMPAIS
              FROM PAIS
             WHERE NRORG = :NRORG
SQL;
        $params = array(
            "NRORG" => $organizationId
        );
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query, $params);
    }
}
